# -*- coding: utf-8 -*-
"""
Created on Fri Oct 10 11:19:24 2014
@name: dstk_json_output_to_csv.py
@author: pattyf@berkeley.edu

This file reads in JSON formatted DSTK streets2coordinates output 
and writes it out as a comma delimited CSV file

"""

import json

#get names of files
# YOU WILL NEED TO UPDATE THESE FILE REFERENCES
infilename = "/Users/patty/Documents/geocoding/dlab-geocoding-tutorial-files/ten_addresses_geocoded.json" 
outfilename = "/Users/patty/Documents/geocoding/dlab-geocoding-tutorial-files/ten_addresses_geocoded.csv"

#open a file to write output to
outfile=open(outfilename,'w')

#read in the json data
json_data = open(infilename)
data = json.load(json_data)
json_data.close()

#Process the output from DSTK
mydelim= ","
#TODO: use the delimiter variable!

mycount=0
numcol = 0
thisRec = []
badRecPad = ","
for d in data:

   if mycount < 1:
       # If here we have not yet processed a record
       # We grab the keys to create the column headers in the output file
       thisRec.append("inaddress")
       thisRec.extend(sorted(data[d].keys()))
       myline = ",".join(thisRec)
       #print(myline)
       outfile.write(myline + "\n")
       
       numcol = len(thisRec)
       #print("number of colums: " + str(numcol))
       mycount += 1 
       
       #Reset the line after writing out the header
       thisRec = []
       myline = "" 
          
       #Also we use the badRecPad to create column separators for
       #addresses for which no data was returned
       for i in range(1,numcol-2):
           badRecPad = badRecPad + ","
           
   #else:
   thisRec.append("\"" + d.rstrip("\n") + "\"")    
   
   if data[d]:
       for k,v in sorted(data[d].items()):
           thisRec.append(str(v))
   else:
       #no data returned
       #todo: need delim numcolumn times!
       thisRec.append(badRecPad)

   myline = ",".join(thisRec)
   #print(myline)
   outfile.write(myline + "\n")
   thisRec = []
   myline = "" 

outfile.close()

